=== debian/changelog ===
gnucash (1:3.6-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.4.0.
  * DH & compat to version 12.
  * Build with "-Wno-error=stringop-truncation" to fix FTBFS with GCC-9
    (Closes: #925700).

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 20 Aug 2019 21:55:11 +1000
